#! /usr/bin/python


"""//Web service to administrate CreditSystem resources//
 
- > This Web service can be use to register the institutions, users, desktop grids and clouds managed by the CreditSystem.
 
- File: admin.py

- Notes: 
 - A database configuration file named "db.cfg" must be present in the directory.

"""
import sys
import os
sys.path.append(os.path.join(sys.path[0],".."))
os.chdir(sys.path[0])
from tools import db_func
from tools import cgi_func
from tools import log_func
log=log_func.get_spequlos_log(__file__)

cgi_func.print_header()

if (cgi_func.get_form_value('User_Identity') is None) or  (cgi_func.get_form_value('User_Institution') is None) :
    
    print "<p>Register a new user (currently the User_Identity must be an integer)</p>"
    cgi_func.print_form(['User_Identity','User_Institution'])

    print "<p>Users already registered:</p><table border=1>"
    conn=db_func.connect(db_func.read_db_config(os.path.join(sys.path[0],"db.cfg")))
    c=conn.cursor()
    try:
        c.execute("SELECT user_id, institution_id, credit_spent FROM QoSUser")
    except db_func.DBError as e:
        log.error("Error during the SQL command execution !")
        log.error(e)
    res=c.fetchall()
    db_func.disconnect(conn)
    
    print "<tr><td>User Identity</td><td>Institution</td><td>Credit Spent</td></tr>" 
    for l in res:
        print "<tr><td>%d</td><td>%d</td><td>%d</td><td><a href=admin_users.py?del=%s>Delete</a></td>" \
                    % (l[0],l[1],l[2],l[0]) 
    print "</table><p>"

else:
    u_id = int(cgi_func.get_form_value('User_Identity'))
    u_institution = int(cgi_func.get_form_value('User_Institution'))

    conn=db_func.connect(db_func.read_db_config(os.path.join(sys.path[0],"db.cfg")))
    c=conn.cursor()
    try:
        c.execute("INSERT QoSUser(user_id,institution_id,credit_spent) VALUES (%d,%d,0)" % (u_id,u_institution))
    except db_func.DBError as e:
        log.error("Error during the SQL command execution !")
        log.error(e)
    db_func.disconnect(conn)
    print "<p>User registered !</p>"
    print "<p> <a href='admin_users.py'>Go back</a></p>"

cgi_func.print_footer()

