drop table if exists QoSUser, Institution, DesktopGrid, Cloud, QoSOrder;

create table QoSUser ( -- Stores the credits spent by each users participating in SpeQulos, for statistics.
        user_id int PRIMARY KEY,
        credit_spent int,
        institution_id int
);

create table Institution ( -- Stores the credits balance for each institution, as well as the credits already won and spent, for statistics.
        institution_id int PRIMARY KEY,
        credit_spent int,
        credit_won int,
        credit_balance int,
        cloud_id int
);

create table DesktopGrid ( -- Stores the credits balance for each DG, as well as the credits already won and spent, for statistics.
        dg_id int PRIMARY KEY,
        credit_balance int,
        credit_spent int,
        credit_won int
);

create table Cloud ( -- Stores the credits spent by each clouds participating in SpeQulos, for statistics.
        cloud_id int PRIMARY KEY,
        credit_spent int 
);

create table QoSOrder ( -- Stores the credit balance for each order created by user for his BoT, as well as the credit originally funded.
        batch_id  varchar(50) PRIMARY KEY,
        credit_funded int,
        credit_balance int,
        user_id int,
        cloud_id int
);
        
