DROP TABLE IF EXISTS CloudService, DesktopGrid, QoSBatch, CloudWorker;

CREATE TABLE CloudService ( -- Stores the information on Cloud services connected to SpeQuloS 
        cloud_service_id VARCHAR(255) PRIMARY KEY NOT NULL,
        cloud_service_conf_file VARCHAR(255) NOT NULL,
        handler ENUM("libcloud","command") NOT NULL
     );

CREATE TABLE DesktopGrid ( -- Stores the information on Desktop Grids connected to SpeQuloS 
        dg_id VARCHAR(255) PRIMARY KEY NOT NULL,
        dg_conf_file VARCHAR(255) NOT NULL
    );

CREATE TABLE QoSBatch ( -- Stores the information on batches currently managed by QoS, for which cloud resources may be assigned to.
        batch_id VARCHAR(255) PRIMARY KEY NOT NULL,
        dg_id VARCHAR(255) NOT NULL,
        batch_data TEXT DEFAULT NULL,
        FOREIGN KEY(dg_id) REFERENCES DesktopGrid(dg_id) ON DELETE CASCADE
    );

CREATE TABLE CloudWorker ( -- Stores the information on Cloud worker available in the system. The cloud worker may be assigned to a batch ("execute" association)
        cloud_worker_id int PRIMARY KEY AUTO_INCREMENT,
        cloud_service_id VARCHAR(255) NOT NULL ,
        cloud_worker_data VARCHAR(255) DEFAULT NULL,
        batch_id VARCHAR(255) DEFAULT NULL,
        FOREIGN KEY(cloud_service_id) REFERENCES CloudService(cloud_service_id) ON DELETE CASCADE,
        FOREIGN KEY(batch_id) REFERENCES QoSBatch(batch_id) ON DELETE SET NULL
    );



